import _toConsumableArray from "@babel/runtime/helpers/esm/toConsumableArray";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import moment from "moment";
import { setIn, updateIn, without } from "seamless-immutable";
var typesToSaveWithHistory = {
  BEGIN_BOX_TRANSFORM: "Transform/Move Box",
  BEGIN_MOVE_POINT: "Move Point",
  DELETE_REGION: "Delete Region"
};
export var saveToHistory = function saveToHistory(state, name) {
  console.log(state, name);
  return updateIn(state, ["history"], function (h) {
    console.log([{
      time: moment().toDate(),
      state: without(state, "history"),
      name: name
    }].concat((h || []).slice(0, 9)));
    return [{
      time: moment().toDate(),
      state: without(state, "history"),
      name: name
    }].concat((h || []).slice(0, 9));
  });
};
export default (function (reducer) {
  return function (state, action) {
    var prevState = state;
    var nextState = reducer(state, action);

    if (action.type === "RESTORE_HISTORY") {
      if (state.history.length > 0) {
        var history_return = function history_return() {
          var obj = {
            annotation: _objectSpread({}, nextState.history[0].state, {
              history_type: nextState.history[0].name
            })
          };

          var newArr = _toConsumableArray(window.annotation_redo);

          newArr.push(obj);
          var final = newArr.filter(function (item, index, self) {
            if (index === self.findIndex(function (t) {
              var _t$annotation, _item$annotation;

              return (t === null || t === void 0 ? void 0 : (_t$annotation = t.annotation) === null || _t$annotation === void 0 ? void 0 : _t$annotation.lastMouseMoveCall) === (item === null || item === void 0 ? void 0 : (_item$annotation = item.annotation) === null || _item$annotation === void 0 ? void 0 : _item$annotation.lastMouseMoveCall);
            })) {
              return item;
            }
          });
          window.annotation_redo = final;
          return setIn(nextState.history[0].state, ["history"], nextState.history.slice(1));
        };

        return history_return();
      }
    } else {
      if (prevState !== nextState && Object.keys(typesToSaveWithHistory).includes(action.type)) {
        return setIn(nextState, ["history"], [{
          time: moment().toDate(),
          state: without(prevState, "history"),
          name: typesToSaveWithHistory[action.type] || action.type
        }].concat(nextState.history || []).slice(0, 9));
      }
    }

    return nextState;
  };
});